# function to plot the faces in R:
# 
# 'face.matrix' must be a matrix of faces arranged column-wise
#
# 'h.pixels' and 'v.pixels' are the number of horizontal and vertical
# pixels of each face in 'face.matrix'
#
# 'n.rows' and 'n.cols' are the dimensions of the canvas in which the
# faces in 'face.matrix' will be plotted

plot.canvas <- function( face.matrix, h.pixels=19, v.pixels=19, n.rows=7,
                        n.cols=7 ){

    nb.pics <- dim( face.matrix )[2]

    par( mfrow=c( n.rows, n.cols ), mar=rep( 0, 4 ) )

    for( i in 1:nb.pics ){

        face <- matrix( face.matrix[,i], nrow=v.pixels, ncol=h.pixels )
        face <- t( face[v.pixels:1,] )
        
        image( face, xaxt='n', yaxt='n', col=grey.colors( h.pixels*v.pixels ) )

    }

}
